/*
 * VBPJHELP.C - Setup Helper module. Part of VBPJSTUB. Written by Michiel de Bruijn,
 *              published in Visual Basic Programmers Journal
 *				updated January 1996 to add OLE server (un)registration functions
 */

#include <dos.h>
#include <string.h>
#include <windows.h>
 
//GetFreeDiskSpace: returns space available (in KB) on drive specified by DriveNumber (1=A, 2=B, etc.)
//				    or -1 if an error occurs (invalid drive)
long int FAR PASCAL GetFreeDiskSpace(int DriveNumber) {


//If we're compiling for Win32, use the API
#ifdef WIN32

	char szRootPathName[4] = "C:\\\0";
	DWORD SectorsPerCluster, BytesPerSector, FreeClusters, Clusters;
    
    szRootPathName[0] = 64 + DriveNumber;

	if(GetDiskFreeSpace(szRootPathName, &SectorsPerCluster, &BytesPerSector, &FreeClusters, &Clusters))
		return BytesPerSector * SectorsPerCluster * FreeClusters / 1024;
	else 
		return -1;

//Otherwise, use plain ol' DOS...
#else

	struct _diskfree_t drive;

	if(_dos_getdiskfree(DriveNumber, &drive) == 0)	
		return (unsigned long) drive.bytes_per_sector * \
			drive.sectors_per_cluster * drive.avail_clusters / 1024;
	else
		return -1;
	
#endif

}

//Generic function used to implement RegisterOleDLL and UnRegisterOleDLL
//(which are really identical, except for the function they call)
int XRegisterOleDll(LPCSTR LibraryName, LPCSTR ProcName) {
	
	HINSTANCE hInstance;
	FARPROC DllRegisterServer;
			    
    //Load library, suppressing file not found system error if not present
    SetErrorMode(SEM_NOOPENFILEERRORBOX);
	hInstance = LoadLibrary(LibraryName);

	DllRegisterServer = GetProcAddress(hInstance, ProcName);	
    
    if(DllRegisterServer == NULL)
		return(0); //Load failed or not OLESelfRegister capable
		
	DllRegisterServer();	
		
	FreeLibrary(hInstance);            
			
	return(-1);
	
}	

//exported RegisterOleDll function
int FAR PASCAL RegisterOleDll(LPCSTR LibraryName) {
	return(XRegisterOleDll(LibraryName, "DllRegisterServer"));	
}	

//exported UnRegisterOleDll function
int FAR PASCAL UnRegisterOleDll(LPCSTR LibraryName) {
	return(XRegisterOleDll(LibraryName, "DllUnRegisterServer"));
}	
