Option Explicit

Declare Function GetProfileString Lib "Kernel" (ByVal lpAppName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer) As Integer
Declare Function GetPrivateProfileString Lib "Kernel" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFileName As String) As Integer

Type ModuleEntry
    dwSize As Long              'Size of the MODULEENTRY structure, in bytes
    szModule As String * 10     'Module name
    hModule As Integer          'Module handle
    wcUsage As Integer          'Reference count of the module
    szExePath As String * 256   'Fully-qualified executable path for the module
    wNext As Integer            'Next entry in module list (Windows internal use only)
End Type

Declare Function ModuleFindName Lib "ToolHelp.DLL" (mo As ModuleEntry, ByVal lpszName As String) As Integer

Sub main ()

'//Skeleton startup procedure for AutoRun-enabled setup app

Dim fInMem As Integer, AppPath As String

If ShouldInstall(fInMem, AppPath) = True Then
    If fInMem = True Then
        '//Ask user to leave app first before re-inserting CD
    Else
        '//Install in AppPath
    End If
Else
    '//Run app (Shell AppPath & "\exename")
End If

End Sub

Function ShouldInstall (fInMem As Integer, AppPath As String) As Integer

'//CheckForPresence: are we already fully installed on this system?
'//(to be used by AutoRun-enabled setup programs)

Dim Res As Integer, tmp As String, tmpl As Integer, INIfile As String
Dim CurVer As Integer, InstVer As Integer, ModName As String

CurVer = 1         'This is version 1 of the application
ModName = "WIDGET" 'And this is our module name
fInMem = False     'Assume not already running

'//Check for the presence of the 'AppPath' key in the [VBPJ Applications]
'//section of WIN.INI, which is always inserted by our setup program
tmp = Space(255): tmpl = Len(tmp)
Res = GetProfileString("VBPJ Applications", "AppPath", "", tmp, tmpl)
AppPath = Trim(Left(tmp, tmpl))

If Len(AppPath) > 1 Then
    '//Found a key, now try to find our private .INI file in this directory
    INIfile = AppPath & "\VBPJ.INI"
    If Len(Dir(INIfile)) Then
        '//Retrieve version number of installed application
        '//('InternalVersion' key in [VBPJ] section)
        tmp = Space(255): tmpl = Len(tmp)
        Res = GetPrivateProfileString("VBPJ", "InternalVersion", "0", tmp, tmpl, INIfile)
        tmp = Trim(Left(tmp, tmpl))
        InstVer = Val(tmp)
    End If
Else
    '//Not present on this system (OK to install)
    ShouldInstall = True
    Exit Function
End If

'//Otherwise, check for presence of our app module in memory
Dim mo As ModuleEntry
fInMem = (ModuleFindName(mo, ModName) <> 0)

'//Need to install if present version is older than this version
ShouldInstall = (InstVer < CurVer)

End Function

