Option Explicit

Declare Function GetFreeDiskSpace Lib "VBPJshlp.DLL" (ByVal DriveNumber As Integer) As Long
Declare Function GetShortPathNameA Lib "VBPJshlp.DLL" Alias "Call32" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long, ByVal Call32ID As Long) As Long
Declare Function Declare32 Lib "VBPJshlp.DLL" (ByVal lpstrName As String, ByVal lpstrLib As String, ByVal lpstrArg As String) As Long

Global Const HKEY_LOCAL_MACHINE = &H80000002

'//FreeSpace: Returns free space on specified drive
'//           (in KB) or -1 if drive is invalid
Function FreeSpace (Drv As String) As Long

FreeSpace = GetFreeDiskSpace(Asc(Drv) - 64)

End Function

Function GetShortPathName (lpszLongPath As String, lpszShortPath As String, cchBuffer As Long) As Long

Static Call32ID

If Call32ID = 0 Then
    '//Register 32-bit function with Call32 library
    Call32ID = Declare32("GetShortPathNameA", "Kernel32.DLL", "ppi")
End If

GetShortPathName = GetShortPathNameA(lpszLongPath, lpszShortPath, cchBuffer, Call32ID)

End Function

Function ShortFile (LongFile As String) As String

Dim Res As Long, tmp As String, tmpl As Long

tmp = Space$(64): tmpl = Len(tmp)
Res = GetShortPathName(LongFile, tmp, tmpl)
ShortFile = tmp

End Function

