Option Explicit

Declare Function LZCopy Lib "LZexpand.DLL" (ByVal hfSource As Integer, ByVal hfDest As Integer) As Long
Declare Function VerInstallFile Lib "Ver.DLL" (ByVal Flags As Integer, ByVal SrcFile As String, ByVal DestFile As String, ByVal SrcPath As String, ByVal DestPath As String, ByVal CurrDir As String, ByVal TmpFile As String, lpwTmpFileLen As Integer) As Long

Global Const OS_HANDLE = 2
Global Const LZERROR_BADINHANDLE = -1
Global Const LZERROR_BADOUTHANDLE = -2
Global Const LZERROR_READ = -3
Global Const LZERROR_WRITE = -4
Global Const LZERROR_GLOBALLOC = -5
Global Const LZERROR_GLOBLOCK = -6
Global Const LZERROR_BADVALUE = -7
Global Const LZERROR_UNKNOWNALG = -8

Sub main ()

On Error Resume Next

Dim Res As Long, Source As String, Dest As String
Dim VBhSource As Integer, VBhDest As Integer
Dim hSource As Integer, hDest As Integer

'//Example of copying a file while expanding it
'//(file should be compressed using COMPRESS -R)

'//First, open the files using regular VB functions
VBhSource = FreeFile: Source = "A:VER.DL_"
Open Source For Binary As VBhSource
VBhDest = FreeFile: Dest = "C:\TMP\VER.DLL"
Open Dest For Binary As VBhDest

'//Obtain DOS file handles for the VB file numbers
hSource = FileAttr(VBhSource, OS_HANDLE)
hDest = FileAttr(VBhDest, OS_HANDLE)

'//Call LZCopy and check the return value
Select Case LZCopy(hSource, hDest)
    Case LZERROR_BADINHANDLE, LZERROR_BADOUTHANDLE
        MsgBox "One or both files could not be opened"
    Case LZERROR_READ, LZERROR_UNKNOWNALG
        MsgBox "Bad input file format"
    Case LZERROR_WRITE
        MsgBox "Insufficient disk space to write output file"
    Case LZERROR_GLOBALLOC, LZERROR_GLOBLOCK
        MsgBox "Memory allocation error"
    Case LZERROR_BADVALUE
        MsgBox "Internal LZCopy error"
    Case Else
        If Err = 0 Then
            'Assume everything went fine
        Else
            'VB error occurred (probably Disk Not Ready)
            MsgBox Error$(Err)
        End If
End Select

'//Close files and remove output file if empty
Close VBhSource, VBhDest
If FileLen(Dest) = 0 Then Kill Dest

End Sub

