VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CSplitter"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
Private CurrentSplit As Integer
Private Splitter As Control
Private Splittees As New Collection
Private LStretch As String  'ID of stretchable control
Private RStretch As String
Private ContainerLeft As Integer
Private ContainerWidth As Integer
Private ContainerTop As Integer
Private ContainerHeight As Integer

Public Sub Split()
'splits to new left
Dim Diff%
Dim SC As CSplittee
Diff = (Splitter.Left + Splitter.Width \ 2) - CurrentSplit
For Each SC In Splittees
    If SC.IsLeft Then
        SC.Ctrl.Width = SC.Ctrl.Width + Diff
    Else
        SC.Ctrl.Left = SC.Ctrl.Left + Diff
        SC.Ctrl.Width = SC.Ctrl.Width - Diff
    End If
Next
CurrentSplit = CurrentSplit + Diff
Set SC = Nothing
End Sub

Public Sub ChangeWidth(NewWidth As Integer)
'changes the width
Dim Diff%
Dim SC As CSplittee
Diff = ContainerWidth - NewWidth
For Each SC In Splittees
    If Not SC.IsLeft And SC.Ctrl.Width > Diff Then 'only change Right controls
        SC.Ctrl.Width = SC.Ctrl.Width - Diff
    End If
Next
ContainerWidth = NewWidth
Set SC = Nothing
End Sub

Public Sub ChangeHeight(NewHeight As Integer)
'changes the height
Dim Diff%
Dim SCL As CSplittee
Dim SCR As CSplittee
Dim SC As CSplittee
Diff = ContainerHeight - NewHeight
Splitter.Height = Splitter.Height - Diff
Set SCL = Splittees(LStretch)
If SCL.Ctrl.Height > Diff Then ' change left stretch control
        SCL.Ctrl.Height = SCL.Ctrl.Height - Diff
End If
Set SCR = Splittees(RStretch)
If SCR.Ctrl.Height > Diff Then ' change Right stretch controls
        SCR.Ctrl.Height = SCR.Ctrl.Height - Diff
End If
'now fix top of other controls
For Each SC In Splittees
    If SC.IsLeft Then
        If SC.Ctrl.Top > SCL.Ctrl.Top Then  'if below
            SC.Ctrl.Top = SC.Ctrl.Top - Diff
        End If
    Else
        If SC.Ctrl.Top > SCR.Ctrl.Top Then  'if below
            SC.Ctrl.Top = SC.Ctrl.Top - Diff
        End If
    End If
Next
ContainerHeight = NewHeight
Set SC = Nothing
Set SCL = Nothing
Set SCR = Nothing
End Sub

Public Sub Register(SplitControl As Control)
'register the control that acts as splitter
'saves the initial container dimensions
ContainerLeft = SplitControl.Parent.Left
ContainerTop = SplitControl.Parent.Top
ContainerWidth = SplitControl.Parent.ScaleWidth
ContainerHeight = SplitControl.Parent.ScaleHeight
SplitControl.Top = 0
SplitControl.Height = ContainerHeight
CurrentSplit = SplitControl.Left + SplitControl.Width \ 2
Set Splitter = SplitControl
End Sub

Public Sub Add(ByVal Ctrl As Control, IsLeft As Boolean, IsStretch As Boolean)
'adds a control object and save if the stretch control
Dim MySplittee As New CSplittee
MySplittee.IsLeft = IsLeft
Set MySplittee.Ctrl = Ctrl
Splittees.Add MySplittee, Ctrl.Name
If IsStretch Then
    If IsLeft Then
        LStretch = Ctrl.Name
    Else
        RStretch = Ctrl.Name
    End If
End If
Set MySplittee = Nothing
End Sub
