VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cWaveMix"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
'------------------------------------------------------------
' cWaveMix Class - encapsulates the WavMix32 DLL.
' Visual Basic 4.0
' written by Mark Pruett
'------------------------------------------------------------

Dim Channel(0 To 7) As tChannelInfo

Public CurrentChannel As Long

'------------------------------------------------------------
' The Initialize Event - makes sure the WaveMix DLL is
' started properly.
'------------------------------------------------------------
Private Sub Class_Initialize()
    If Not WAVMIX_InitMixer() Then
        MsgBox "Unable to Initialize WaveMix DLL", _
               vbOKOnly Or vbExclamation, _
               "WaveMix Error"
        End
    End If
End Sub

'------------------------------------------------------------
' The Terminate Event - makes sure the WaveMix DLL is shut
' down properly.
'------------------------------------------------------------
Private Sub Class_Terminate()
    WAVMIX_Close
End Sub

'------------------------------------------------------------
' The Play Method - starts playing the wave file associated
' with the current channel.
'------------------------------------------------------------
Public Sub Play()
    WAVMIX_PlayChannel CurrentChannel, Channel(CurrentChannel).Loops
End Sub

'------------------------------------------------------------
' The FileName Property - associates the current channel
' with a particular wave file.
'------------------------------------------------------------
Public Property Get FileName() As String
    FileName = Channel(CurrentChannel).WaveFile
End Property

Public Property Let FileName(ByVal AFileName As String)
    Channel(CurrentChannel).WaveFile = AFileName
    WAVMIX_SetFile Channel(CurrentChannel).WaveFile, CurrentChannel
End Property

'------------------------------------------------------------
' The Quit Method - Stops the current channel if it's
' playing.
'------------------------------------------------------------
Public Sub Quit()
    WAVMIX_StopChannel CurrentChannel
End Sub

'------------------------------------------------------------
' The AutoLoop Property - determines if the current channel
' will loop its wave file.
'------------------------------------------------------------
Public Property Get AutoLoop()
    AutoLoop = Channel(CurrentChannel).Loops
End Property

Public Property Let AutoLoop(LoopWave)
    Channel(CurrentChannel).Loops = LoopWave
End Property
