Attribute VB_Name = "Module1"
Option Explicit

'  The database load program can only run in 32-bit using RDO

'  Written by Steve Jackson
'  Huntington Beach, California
'  Compuserve: 72040,1640
'  This program was used for the database testing in Steve's
'  article in Visual Basic Programmers Journal, May 1996

'
'  Modify these 2 lines with your ODBC data source, userid, password
Global Const MY_ODBC_DSN = "SqlServer32"
Global Const MY_ODBC_API_CONNECT = "DSN=SqlServer32;UID=sjackson;PWD=****;"
    ' change to your datasource and userid, password
Global Const MY_RDO_CONNECT = "DSN=SqlServer32;UID=sjackson;PWD=****"

Declare Function GetTickCount Lib "Kernel32" () As Long

Dim lname(1 To 20) As String
Dim fname(1 To 20) As String
Dim state(1 To 20) As String
Dim prod(1 To 10) As String
Dim prod1(1 To 10) As String
Global bCancel As Integer

Dim rdoEnv As rdoEnvironment
Dim rdoConn As rdoConnection
Dim rs As rdoResultset
Dim rdoPStmtCustInsert As rdoPreparedStatement

Dim lMaxCust As Long
Dim lMaxProduct As Long
Dim lMaxOrder As Long
Dim lMaxProductCode As Long

Dim lTransCount As Long




Sub DoClearTransLog()
    rdoConn.Execute "dump transaction test to diskdump with no_log"
    rdoConn.Execute "dump database test to diskdump"
    rdoConn.Execute "dump transaction test to diskdump"
End Sub

Sub DoCloseDatabase()
    rdoConn.Close
    rdoEnv.Close
End Sub

Sub DoLoad()
    Dim lStart As Long, lEnd As Long
    
    lMaxCust = 100000
    lMaxProduct = 1000
    lMaxProductCode = 200
    lMaxOrder = 5000
    bCancel = 0
    
    Form1!label1 = "Emptying database"
    Call DoEmptyDatabase
    Form1!cmdStartLoad.Enabled = False
    
    lStart = GetTickCount()
    Form1!label1 = "Loading products"
    Call LoadProduct
    
    Form1!label1 = "Loading product codes"
    Call LoadProductCodes
    
    Form1!label1 = "Loading orders"
    Call LoadOrder
    
    Form1!label1 = "Loading " & Str$(lMaxCust) & " customers"
    Call LoadCust
    
    rdoConn.Close
    
    lEnd = GetTickCount()
    Beep
    Form1!label1 = "Done"
    Form1!cmdStartLoad.Enabled = True
    Form1!label2 = "Seconds to load: " & Str$((lEnd - lStart) / 1000)
End Sub


Sub DoEmptyDatabase()
    ' send this short SQL statement thru
    '  to delete ALL THE ROWS from EACH TABLE!!!
    Dim r As Integer
   
    rdoConn.Execute "Delete Customer"
    rdoConn.Execute "Delete Product"
    rdoConn.Execute "Delete ProductCode"
    rdoConn.Execute "Delete OrderEntry"
End Sub


Function GetRand(lo As Integer, hi As Integer) As Integer
    GetRand = Int((hi - lo + 1) * Rnd + lo)
End Function

Sub LoadCust()
    Dim i As Integer
    Dim k As Long, max As Long
    Dim j As Integer
    Dim sSQLStmt As String
    Dim sKey As String * 10
        
    On Local Error GoTo LoadCustError
    sSQLStmt = "insert into customer values(?, ?, ?, ?, ?, ?)"
    Set rdoPStmtCustInsert = rdoConn.CreatePreparedStatement("InsertCust", sSQLStmt)

    rdoEnv.BeginTrans
    max = lMaxCust
    lTransCount = 0
    For k = 1 To max
        i = GetRand(1, 20)
        j = j + 1
        If j = 10 Then
            Form1!label2 = Str$(k)
            j = 0
            rdoEnv.CommitTrans
            rdoEnv.BeginTrans
        End If
        
        DoEvents
        If bCancel Then
            bCancel = 0
            k = max + 1
        End If
        
        sKey = Trim$(Str$(k + 400000))
        rdoPStmtCustInsert.rdoParameters(0) = sKey
        rdoPStmtCustInsert.rdoParameters(1) = lname(i)
        rdoPStmtCustInsert.rdoParameters(2) = fname(i)
        rdoPStmtCustInsert.rdoParameters(3) = state(i)
        'rdoPStmtCustInsert.rdoParameters(4) = "c"
        'rdoPStmtCustInsert.rdoParameters(5) = "1"

        rdoPStmtCustInsert.Execute
        
        lTransCount = lTransCount + 1
        If lTransCount = 5000 Then
            ' clear the transaction log
            ' so it doesn't fill up
            rdoEnv.CommitTrans
            Call DoClearTransLog
            lTransCount = 0
            rdoEnv.BeginTrans
        End If

    Next k
    Exit Sub
LoadCustError:
    MsgBox "Error on cust insert: " & sKey & " msg: " & Error$
    Exit Sub
End Sub




Sub LoadDatafields()
    lname(1) = "Smith"
    lname(2) = "Jones"
    lname(3) = "Chen"
    lname(4) = "Sanchez"
    lname(5) = "Jackson"
    lname(6) = "Franks"
    lname(7) = "Clinton"
    lname(8) = "Dole"
    lname(9) = "Nixon"
    lname(10) = "Davis"
    lname(11) = "Shaw"
    lname(12) = "Yarbrough"
    lname(13) = "Jackson"
    lname(14) = "Clark"
    lname(15) = "McCartney"
    lname(16) = "Wilson"
    lname(17) = "Majors"
    lname(18) = "Lee"
    lname(19) = "Anderson"
    lname(20) = "Nguyen"
    fname(1) = "Pat"
    fname(2) = "Joe"
    fname(3) = "Richard"
    fname(4) = "Steve"
    fname(5) = "Pamela"
    fname(6) = "John"
    fname(7) = "Louis"
    fname(8) = "Paula"
    fname(9) = "Mike"
    fname(10) = "Tom"
    fname(11) = "Larry"
    fname(12) = "Sally"
    fname(13) = "Kyle"
    fname(14) = "Mary"
    fname(15) = "Suzy"
    fname(16) = "John"
    fname(17) = "Jim"
    fname(18) = "Barbara"
    fname(19) = "Abraham"
    fname(20) = "Karen"
    state(1) = "CA"
    state(2) = "AZ"
    state(3) = "NV"
    state(4) = "MA"
    state(5) = "FL"
    state(6) = "HI"
    state(7) = "AK"
    state(8) = "WA"
    state(9) = "WI"
    state(10) = "NY"
    state(11) = "PA"
    state(12) = "CA"
    state(13) = "TN"
    state(14) = "OH"
    state(15) = "IN"
    state(16) = "ID"
    state(17) = "WY"
    state(18) = "SC"
    state(19) = "NC"
    state(20) = "CA"
    prod(1) = "Paper"
    prod(2) = "Flange"
    prod(3) = "Gadget"
    prod(4) = "Widget"
    prod(5) = "Thing"
    prod(6) = "Stuff"
    prod(7) = "Envelope"
    prod(8) = "Cutter"
    prod(9) = "Splicer"
    prod(10) = "Gizmo"
    prod1(1) = "Laser"
    prod1(2) = "Business"
    prod1(3) = "Circular"
    prod1(4) = "Official"
    prod1(5) = "Premium"
    prod1(6) = "Deluxe"
    prod1(7) = "Budget"
    prod1(8) = "Platinum"
    prod1(9) = "Chrome"
    prod1(10) = "Brass"
End Sub

Sub DoOpenDatabase()
    Dim dsn As String
    Dim sConnect As String
    
    On Local Error GoTo DoOpenDatabaseError
    dsn = "SqlServer32"
    Set rdoEnv = rdoEnvironments(0)
    sConnect = MY_RDO_CONNECT
    Set rdoConn = rdoEnv.OpenConnection("", rdDriverComplete, False, sConnect)
    Exit Sub
    
DoOpenDatabaseError:
    MsgBox "Error: " & Error$(Err), 48
    End
End Sub



Sub LoadOrder()
    Dim i As Integer
    Dim k As Long, max As Long
    Dim y As String, m As String, d As String, dnum As Integer
    Dim j As Integer
        
    On Local Error GoTo LoadOrderError
    Set rs = rdoConn.OpenResultset("Select * from OrderEntry", rdOpenKeyset, rdConcurRowver)
    
    max = lMaxOrder
    For k = 1 To max
        j = j + 1
        If j = 10 Then
            Form1!label2 = Str$(k)
            j = 0
            rdoEnv.CommitTrans
        End If
        
        DoEvents
        If bCancel Then
            bCancel = 0
            k = max + 1
        End If
        
        rs.AddNew
        rs("OrderID") = Trim$(Str$(k))
        rs("CustID") = Trim$(Str$(GetRand(1, 200)))
        
        y = Trim$(Str$(GetRand(72, 95)))
        m = Trim$(Str$(GetRand(1, 12)))
        dnum = GetRand(1, 20)
        d = Trim$(Str$(dnum))
        rs("OrderDate") = m & "/" & d & "/" & y
        rs("OrderYear") = y
        rs("OrderMonth") = m
        If GetRand(1, 5) <> 2 Then
            rs("ShipDate") = m & "/" & Trim$(Str$(dnum + 1)) & "/" & y
        Else
            rs("ShipDate") = " "
        End If
        
        rs.Update
    Next k
    rs.Close
    Exit Sub
LoadOrderError:
    MsgBox Error$(Err)
    Exit Sub
End Sub

Sub LoadProduct()
    Dim i As Integer
    Dim k As Long, max As Long
    Dim j As Integer
        
    Set rs = rdoConn.OpenResultset("Select * from Product", rdOpenKeyset, rdConcurRowver)
    
    max = lMaxProduct
    For k = 1 To max
        i = GetRand(1, 10)
        j = j + 1
        If j = 10 Then
            Form1!label2 = Str$(k)
            j = 0
            rdoEnv.CommitTrans
        End If

        
        DoEvents
        If bCancel Then
            bCancel = 0
            k = max + 1
        End If
        
        rs.AddNew
        rs("ProductID") = Trim$(Str$(k))
        rs("ProductName") = prod1(i) & " " & prod(i)
        rs("ProductCode") = Trim$(Str$(GetRand(1, 200)))
        rs("QtyOnHand") = GetRand(100, 200)
        
        rs.Update
    Next k
    rs.Close

End Sub


Sub LoadProductCodes()
    Dim i As Integer
    Dim k As Long, max As Long
    Dim j As Integer
        
    Set rs = rdoConn.OpenResultset("Select * from ProductCode", rdOpenKeyset, rdConcurRowver)

    max = lMaxProductCode
    For k = 1 To max
        j = j + 1
        If j = 10 Then
            Form1!label2 = Str$(k)
            j = 0
            rdoEnv.CommitTrans
        End If
        
        DoEvents
        If bCancel Then
            bCancel = 0
            k = max + 1
        End If
        
        rs.AddNew
        rs("ProductCode") = Trim$(Str$(k))
        rs("ProductDescription") = "Product type " & Str$(k)
      
        rs.Update
    Next k
    rs.Close
End Sub


