/****************************************************************************
*
*		Thread DLL for Visual Basic Programmer's Journal Article
*		Copyright  1996 Stephen R. Husak
*
*		PROJECT		:	Thread
*		FILENAME	:	thread.h
*		AUTHOR		:	12/26/95	SRH
*
*		PURPOSE		:	application header file defining global variables and constants
*								     
*		REVISIONS	:	12/26/95	SRH		original file creation
*								01/01/96	SRH		added textbox handles to the DIRDATA struct
*								01/05/96	SRH		added full commentation
*        
****************************************************************************/

#ifndef __THREAD_H__
#define __THREAD_H__

/*
 * Application Constants
 */
#define DLLEXPORT _declspec(dllexport)			// for readability

/*
 * Application Global Variables & Types
 */
#define MAX_FILE_SPEC 10						// file spec length should not exceed this
#define MAX_FILE_PATH 256						// path length should not exceed this
																		// this are set to these values since in 
																		// this example, file spec is always *.*
																		// and the path in the struct is always
																		// two characters (drive letter & :) C:

DWORD gl_DirCount = 0;							// directory/folder counter
DWORD gl_FileCount = 0;							// file counter

typedef struct {
	HWND hWndList;										// handle to list box for data output
	HWND hWndDirs;										// handle to text box for directory count
	HWND hWndFiles;										// handle to text box for file count
	char filespec[MAX_FILE_SPEC];			// file specification (eg. *.*)
	DWORD lFileSpecLen;								// length of filespec in characters
	char path[MAX_FILE_PATH];					// path (eg. C:\)
	DWORD lPathLen;										// length of path in characters
} DIRDATA;

/*
 * Function Prototypes
 */
BOOL WINAPI DllMain(HINSTANCE, DWORD, LPVOID);
DLLEXPORT DWORD WINAPI DirBrowseThread(void *);
DLLEXPORT void WINAPI DirBrowse(LPSTR, LPSTR, HWND, HWND, HWND);

#endif /* __THREAD_H__ */
