Option Explicit
'
' global vars
'
Global db As Database       ' single db object
Global ds() As Dynaset      ' data set object array
Global frmList() As Form    ' display form array
Global cDynaset() As String ' data set name array
'
Global nFrmCount As Integer ' for forms array
Global nDBOpen As Integer   ' open db flag
Global nErr As Integer      ' error flag

' Field Attributes
Global Const DB_FIXEDFIELD = &H1
Global Const DB_VARIABLEFIELD = &H2
Global Const DB_AUTOINCRFIELD = &H10
Global Const DB_UPDATABLEFIELD = &H20

' Field Data Types
Global Const DB_BOOLEAN = 1
Global Const DB_BYTE = 2
Global Const DB_INTEGER = 3
Global Const DB_LONG = 4
Global Const DB_CURRENCY = 5
Global Const DB_SINGLE = 6
Global Const DB_DOUBLE = 7
Global Const DB_DATE = 8
Global Const DB_TEXT = 10
Global Const DB_LONGBINARY = 11
Global Const DB_MEMO = 12

Function GenForm (cDB As String, cRS As String, nMode As Integer) As Integer
    '
    On Error GoTo GenFormErr
    '
    nErr = False
    GenForm = -1 ' assume an error occurs
    If nDBOpen = False Then
        OpenDB cDB      ' open database
    End If
    '
    If nErr = False Then
        GenForm = LoadForm(cRS, nMode) ' load recordset
    End If
    GoTo GenFormExit
    '
GenFormErr:
   MsgBox "Err:" & Str(Err) & "[" & Error(Err) & "]", 0, "GenMain Error"
   nErr = True
   nDBOpen = False
   GenForm = -1
   Resume Next
   
GenFormExit:
    '
End Function

Function LoadForm (cRecordSource As String, nMode As Integer) As Integer
    '
    ' get recordsource and start a new form
    '
    On Error GoTo LoadFormErr
    '
    '
    nFrmCount = nFrmCount + 1
    ReDim Preserve frmList(nFrmCount) As Form
    ReDim Preserve cDynaset(nFrmCount) As String
    ReDim Preserve ds(nFrmCount) As Dynaset
    '
    cDynaset(nFrmCount) = cRecordSource
    Set frmList(nFrmCount) = New frmGenForm
    Load frmList(nFrmCount)
    frmList(nFrmCount).Show nMode
    '
    LoadForm = nFrmCount
    GoTo LoadFormExit
    '
LoadFormErr:
    MsgBox "Err:" & Str(Err) & "[" & Error(Err) & "]", 0, "LoadForm Error"
    nErr = True
    LoadForm = -1
    Resume Next
    '
LoadFormExit:
    '
End Function

Sub OpenDB (cDBF As String)
   '
   On Error GoTo OpenDBErr
   '
   ' open new db
   Set db = OpenDatabase(cDBF, False, False)
   If nErr = False Then
      nDBOpen = True
   Else
      nDBOpen = False
   End If
   GoTo OpenDBExit

OpenDBErr:
   MsgBox "Err:" & Str(Err) & "[" & Error(Err) & "]", 0, "OpenDB Error"
   nErr = True
   Resume Next
   '
OpenDBExit:
   '
End Sub

