Attribute VB_Name = "JetVB4"
Option Explicit

Dim ws As Workspace
Dim db As Database
Dim rs As Recordset
Dim q As QueryDef

Dim sSQLStmt As String

Dim mbSQLPassthru As Integer
Dim mbAttachedMDB As Integer
Dim mbQueryDef As Integer

Sub DoJetTest(iTestType As Integer)
    Dim nRows As Long
    Dim sData As String
    Dim i As Integer
    Dim lStart As Long, lEnd As Long
    Dim iMax As Integer
    Dim sDateTime  As String
    
    Screen.MousePointer = 11
    Call ClearForm
    iMax = 20
    sDateTime = Date$ & " " & Time$ & " "
    ShowStatus "Starting Test " & sDateTime
    ShowTotMsg "Starting Test " & sDateTime
    
    mbAttachedMDB = 0
    mbSQLPassthru = 0
    mbQueryDef = 0

    Select Case iTestType
        Case 0
            ShowStatus "JET ODBC Connection"
            ShowTotMsg "JET ODBC Connection"
            StartTimeCount "Open database"
        Case 1
            mbAttachedMDB = 1
            ShowStatus "JET Attached MDB"
            ShowTotMsg "JET Attached MDB"
            StartTimeCount "Open database"
        Case 2
            mbSQLPassthru = 1
            ShowStatus "JET SQL Passthru"
            ShowTotMsg "JET SQL Passthru"
            StartTimeCount "Open database"
        Case 3
            mbAttachedMDB = 1
            mbQueryDef = 1
            mbSQLPassthru = 0
            ShowStatus "JET QueryDef"
            ShowTotMsg "JET QueryDef"
            StartTimeCount "Open database"
    End Select


    lStart = GetTickCount()
    
    Call JetOpenDatabase(mbAttachedMDB)
    ShowStatus (EndTimeCount())

    '  SELECT tests -------------------------
    StartTimeCount "Select row by indexed key"
    sData = JetGetRowByKey("19099")
    ShowStatus (EndTimeCount())
    ShowStatus "        Row: " & sData
       
    StartTimeCount "Select different row by indexed key"
    sData = JetGetRowByKey("19086")
    ShowStatus (EndTimeCount())
    ShowStatus "        Row: " & sData

    StartTimeCount "Select first row again by indexed key"
    sData = JetGetRowByKey("19099")
    ShowStatus (EndTimeCount())
    ShowStatus "        Row: " & sData

    Call CalcRandKeys
    StartTimeCount "SELECT " & Str$(iMax) & " ROWS by indexed key"
    For i = 1 To iMax
        sData = JetGetRowByKey(msRandKey(i))
    Next i
    ShowStatus (EndTimeCount())
       
    StartTimeCount "SELECT ALL ROWS (200 row table)"
    nRows = JetReadAllRows()
    ShowStatus (EndTimeCount())
    ShowStatus "        Rows: " & Str$(nRows)

    StartTimeCount "SELECT ROWS by non-indexed search value"
    nRows = JetGetRowBySearchValue("117")
    ShowStatus (EndTimeCount())
    ShowStatus "        Rows: " & Str$(nRows)

    '   UPDATE tests -----------------------------------
    msDateToday = Date$
    StartTimeCount "Update 1 row by indexed key value"
    nRows = JetUpdateRow("22")
    ShowStatus (EndTimeCount())
    If nRows = 0 Then ShowStatus "        ERROR updating row"
    
    Call CalcRandKeys
    StartTimeCount "UPDATE" & Str$(iMax) & " ROWS by indexed key value"

    For i = 1 To iMax
        nRows = JetUpdateRow(msRandKey(i))
        If nRows = 0 Then ShowStatus "        ERROR updating row"
    Next i
    ShowStatus (EndTimeCount())
    
    '   INSERT -----------------------------------
    Call CalcNewKeys
   
    If mbSQLPassthru = 0 Then
        Set rs = db.OpenRecordset("Customer", dbOpenDynaset, dbAppendOnly)
    End If

    StartTimeCount "Insert 1 row"
    nRows = JetInsertRow("1A")
    ShowStatus (EndTimeCount())
    If nRows = 0 Then ShowStatus "        ERROR inserting row"
    
    StartTimeCount "INSERT " & Str$(iMax) & " ROWS"
    For i = 1 To iMax
        nRows = JetInsertRow(msRandKey(i))
        If nRows = 0 Then ShowStatus "        ERROR inserting row"
    Next i
    ShowStatus (EndTimeCount())
    
    If mbSQLPassthru = 0 Then
        rs.Close
    End If
    
    '    DELETE  -------------------------------------
    StartTimeCount "Delete 1 row"
    
    nRows = JetDeleteRow("1A")
    ShowStatus (EndTimeCount())
    If nRows = 0 Then ShowStatus "        ERROR deleting row"

    StartTimeCount "DELETE " & Str$(iMax) & " ROWS"
    For i = 1 To iMax
        nRows = JetDeleteRow(msRandKey(i))
        If nRows = 0 Then ShowStatus "        ERROR deleting row"
    Next i
    ShowStatus (EndTimeCount())

    '    JOIN   ------------------------------------------
    StartTimeCount "SELECT 2 TABLE JOIN"
    nRows = JetSelectJoin("98")
    ShowStatus (EndTimeCount())
    ShowStatus "        Rows: " & Str$(nRows)
    '-------------------------------------
    
    StartTimeCount "Closing database connection"
    Call JetCloseDatabase
    ShowStatus (EndTimeCount())
    lEnd = GetTickCount()

    Screen.MousePointer = 0
    ShowStatus "Done, total time = " & Str$((lEnd - lStart) / 1000)
    ShowStatus "----------------------------------------"
    ShowTotMsg "Done, total time = " & Str$((lEnd - lStart) / 1000)
End Sub

Sub JetCloseDatabase()
    On Error GoTo JetCloseDatabaseErr
    db.Close
    
    'JetCloseDatabase = 0
    Exit Sub

JetCloseDatabaseErr:
    MsgBox Error$(Err), 48
    'JetCloseDatabase = 1
    Exit Sub
End Sub

Function JetDeleteRow(sKeyValue As String) As Long
    Dim sKey As String * 10
    Dim nRows As Long
    
    sKey = sKeyValue
    
    If mbSQLPassthru Then
        sSQLStmt = "DELETE Customer WHERE CustID = " & SQ & sKey & SQ
        nRows = db.ExecuteSQL(sSQLStmt)
        JetDeleteRow = nRows
        Exit Function
    End If
    
    sSQLStmt = "Select * from Customer where CustID = " & DQ & sKey & DQ
    Set rs = db.OpenRecordset(sSQLStmt, dbOpenDynaset)
    If rs.EOF Then
        rs.Close
        JetDeleteRow = 0
        Exit Function
    End If

    rs.Edit
    rs.Delete
    rs.Close
    
    JetDeleteRow = 1
End Function



Function JetGetRowByKey(sKeyValue As String) As String
    Dim sKey As String * 10

    sKey = sKeyValue
    sSQLStmt = "Select LastName, FirstName from Customer where CustID = " & DQ & sKey & DQ
   
    If mbQueryDef Then
        Set q = db.OpenQueryDef("SelectCustomerByKey")
        q![Get CustID] = sKey
        Set rs = q.CreateDynaset()
        q.Close
    Else
      If mbSQLPassthru Then
        sSQLStmt = "Select LastName, FirstName from Customer where CustID = " & SQ & sKey & SQ
        Set rs = db.OpenRecordset(sSQLStmt, dbOpenDynaset, dbSQLPassThrough)
      Else
        Set rs = db.OpenRecordset(sSQLStmt, dbOpenDynaset)
      End If
    End If

    If Not rs.EOF Then
        JetGetRowByKey = RTrim$(rs("LastName")) & ", " & RTrim$(rs("FirstName"))
    Else
        JetGetRowByKey = "ERROR - NONE FOUND!"
    End If
        
    rs.Close
End Function

Function JetGetRowBySearchValue(sSearchValue As String) As Long
    Dim nRows As Long
    Dim sData As String
    Dim sValue As String * 10

    sValue = sSearchValue
    sSQLStmt = "Select ProductName from Product where ProductCode = " & DQ & sValue & DQ
    
    If mbSQLPassthru Then
        sSQLStmt = "Select ProductName from Product where ProductCode = " & SQ & sValue & SQ
        Set rs = db.OpenRecordset(sSQLStmt, dbOpenDynaset, dbSQLPassThrough)
    Else
        If mbQueryDef Then
            Set q = db.OpenQueryDef("SelectRowsBySearchValue")
            q![Get SearchValue] = sValue
            Set rs = q.CreateDynaset()
            q.Close
        Else
            Set rs = db.OpenRecordset(sSQLStmt, dbOpenDynaset)
        End If
    End If
    
    nRows = 0
    While Not rs.EOF
        sData = rs("ProductName")
        rs.MoveNext
        nRows = nRows + 1
    Wend
    rs.Close

    JetGetRowBySearchValue = nRows
End Function

Function JetInsertRow(sKeyValue As String) As Long
    Dim sKey As String * 10
    Dim sDate As String * 10, iTimesOrderPlaced As Integer
    Dim nRows As Long
    
    sKey = sKeyValue
    On Local Error GoTo JetInsertRowError
    
    If mbSQLPassthru Or mbQueryDef Then
        ' insert into customer values("A1", "Jack", "x", "x", "x", 21)
        sSQLStmt = "INSERT Into Customer values("
        sSQLStmt = sSQLStmt & SQ & sKey & SQ & ", "
        sSQLStmt = sSQLStmt & SQ & "test" & SQ & ", "
        sSQLStmt = sSQLStmt & SQ & "test" & SQ & ", "
        sSQLStmt = sSQLStmt & SQ & "OH" & SQ & ", "
        sSQLStmt = sSQLStmt & SQ & "test" & SQ & ", "
        sSQLStmt = sSQLStmt & " 1)"
        If mbSQLPassthru Then
            nRows = db.ExecuteSQL(sSQLStmt)
            JetInsertRow = nRows
            'db.Execute sSQLStmt, dbSQLPassThrough
            'JetInsertRow = 1  '  stmt does not return nRows
            Exit Function
        Else
            Set q = db.OpenQueryDef("InsertNewCustomer")
            q.SQL = sSQLStmt
            q.Execute
            q.Close
            JetInsertRow = 1
            Exit Function
        End If
    End If
    
    rs.AddNew
    rs("CustID") = sKey
    rs("LastName") = "New"
    rs("FirstName") = "Test stuff"
    rs("State") = "CA"
    rs("LastOrderDate") = msDateToday
    rs("TimesOrderPlaced") = 1
    rs.Update
    
    JetInsertRow = 1
    Exit Function

JetInsertRowError:
    JetInsertRow = 0
    Exit Function

End Function

Sub JetOpenDatabase(bAttachedMDB As Integer)
    Dim sDatabaseName As String
    Static bInitialized As Integer
    
    If Not bInitialized Then
        Set ws = DBEngine.Workspaces(0)
        bInitialized = True
    End If
    
    On Error GoTo JetOpenDatabaseErr
    
    If bAttachedMDB Then
        '  Access MDB attached to SQL database
        sDatabaseName = App.Path & "\" & MY_MDB_NAME   ' Attached MDB name
        Set db = ws.OpenDatabase(sDatabaseName, False, False)
        If mbQueryDef Then
            Call JetCreateQueryDefs
        End If
    Else
        '  ODBC database
        sDatabaseName = MY_ODBC_DSN  '  ODBC Data Source name
        Set db = ws.OpenDatabase(sDatabaseName, False, False, MY_ODBC_CONNECT)
    End If
    
    'JetOpenDatabase = 0
    Exit Sub

JetOpenDatabaseErr:
    MsgBox Error$(Err), 48
    'JetOpenDatabase = 1
    Exit Sub
End Sub

Sub JetCreateQueryDefs()
    ' The queries may not exist yet,
    ' so create them here
    ' After this is done, you could remove
    ' this subroutine
    Static bQueryDefsCreated As Integer
    If bQueryDefsCreated Then
        Exit Sub
    End If
  
    On Local Error Resume Next
    db.DeleteQueryDef ("SelectCustomerByKey")
    db.DeleteQueryDef ("SelectCustomerOrder")
    db.DeleteQueryDef ("SelectRowsBySearchValue")
    db.DeleteQueryDef ("SelectAllProductCodes")
    db.DeleteQueryDef ("InsertNewCustomer")
    db.DeleteQueryDef ("DeleteCustomer")

    Set q = db.CreateQueryDef("SelectCustomerByKey")
    q.SQL = "PARAMETERS [Get CustID] TEXT;Select * from Customer where CustID = [Get CustID]"
    q.Close
    Set q = db.CreateQueryDef("SelectCustomerOrder")
    q.SQL = "PARAMETERS [Get CustID] TEXT;Select LastName, OrderDate, Shipdate from Customer, OrderEntry  where customer.CustID = [Get CustID] and customer.custid = orderentry.custid"
    q.Close
    Set q = db.CreateQueryDef("SelectRowsBySearchValue")
    q.SQL = "PARAMETERS [Get SearchValue] TEXT;Select ProductName from Product where ProductCode = [Get SearchValue]"
    q.Close
    Set q = db.CreateQueryDef("SelectAllProductCodes")
    q.SQL = "Select * from ProductCode"
    q.Close

    ' This SQL is just a place holder -
    ' the real SQL will be added at execute time
    ' for both INSERT and DELETE action queries
    ' since paramaters don't work on
    ' SQL passthru queries
    Set q = db.CreateQueryDef("InsertNewCustomer")
    q.SQL = "Insert into Customer values('A1', 'Jack', 'x', 'x', 'x', 21)"
    q.Close
    Set q = db.CreateQueryDef("DeleteCustomer")
    'q.SQL = "Delete Customer where CustID = 'A1'"
    q.Close
    bQueryDefsCreated = True
End Sub

Function JetReadAllRows() As Long
    Dim sData As String
    Dim nRows As Long
    
    sSQLStmt = "SELECT ProductCode, ProductDescription FROM ProductCode"
    
    If mbQueryDef Then
        Set q = db.OpenQueryDef("SelectAllProductCodes")
        Set rs = q.CreateSnapshot ' stj
        q.Close
    Else
      If mbSQLPassthru Then
        Set rs = db.OpenRecordset(sSQLStmt, dbOpenSnapshot, dbReadOnly & dbSQLPassThrough)
      Else
        Set rs = db.OpenRecordset(sSQLStmt, dbOpenSnapshot, dbReadOnly)
        'Set rsnap = db.CreateSnapshot(sSQLStmt) ' , DB_READONLY)
      End If
    End If
    
    
    nRows = 0
    While Not rs.EOF
        sData = Trim$(rs("ProductCode")) & rs("ProductDescription")
        rs.MoveNext
        If nRows < 20 Then
            Form1!List2.AddItem sData
        End If
        nRows = nRows + 1
    Wend
    rs.Close
    
    JetReadAllRows = nRows
End Function

Function JetUpdateRow(sKeyValue As String) As Long
    Dim sKey As String * 10
    Dim sDate As String * 10, iTimesOrderPlaced As Integer
    Dim nRows As Long
    
    sKey = sKeyValue
    ' Update a row - set LastOrderDate to today,
    ' and add 1 to number of times an order was placed

    ' First get the row before updating it...
    sKey = sKeyValue
    
    If mbQueryDef Then
        Set q = db.OpenQueryDef("SelectCustomerByKey")
        q![Get CustID] = sKey
        Set rs = q.CreateDynaset()
        q.Close
    Else
      If mbSQLPassthru Then
        sSQLStmt = "Select LastOrderDate, TimesOrderPlaced from Customer where CustID = " & SQ & sKey & SQ
        Set rs = db.OpenRecordset(sSQLStmt, dbOpenDynaset, dbSQLPassThrough)
      Else
        sSQLStmt = "Select LastOrderDate, TimesOrderPlaced from Customer where CustID = " & DQ & sKey & DQ
        Set rs = db.OpenRecordset(sSQLStmt, dbOpenDynaset)
      End If
    End If

    ' no row found
    If rs.EOF Then
        JetUpdateRow = 0
        rs.Close
        Exit Function
    End If

    ' increment number of times order placed
    If IsNull(rs("TimesOrderPlaced")) Then
        iTimesOrderPlaced = 0
    Else
        iTimesOrderPlaced = rs("TimesOrderPlaced")
    End If
    iTimesOrderPlaced = iTimesOrderPlaced + 1

    ' do the update
    If mbSQLPassthru Then
        rs.Close
        sSQLStmt = "UPDATE Customer set LastOrderDate = " & SQ & msDateToday & SQ & ", TimesOrderPlaced = " & Str$(iTimesOrderPlaced) & " WHERE CustID = " & SQ & sKey & SQ
        nRows = db.ExecuteSQL(sSQLStmt)
        JetUpdateRow = nRows
    Else
        rs.Edit
        rs("LastOrderDate") = msDateToday
        rs("TimesOrderPlaced") = iTimesOrderPlaced
        rs.Update
        rs.Close
        JetUpdateRow = 1
    End If
End Function


Function JetSelectJoin(sKeyValue As String) As Long
    Dim sKey As String * 10
    Dim sSQLStmt As String
    Dim sData As String
    Dim nRows As Long

    sKey = sKeyValue
    nRows = 0

    If mbQueryDef Then
        Set q = db.OpenQueryDef("SelectCustomerOrder")
        q![Get CustID] = sKey
        Set rs = q.CreateDynaset()
        q.Close
    Else
      If mbSQLPassthru Then
    '   select LastName, OrderDate, Shipdate from customer, orderentry where customer.custid = '22' and customer.custid = orderentry.custid
        sSQLStmt = "select LastName, OrderDate, Shipdate from customer, orderentry  where customer.CustID = " & SQ & sKey & SQ & " and customer.custid = orderentry.custid"
        Set rs = db.OpenRecordset(sSQLStmt, dbOpenDynaset, dbSQLPassThrough)
      Else
        sSQLStmt = "select LastName, OrderDate, Shipdate from customer, orderentry  where customer.CustID = " & DQ & sKey & DQ & " and customer.custid = orderentry.custid"
        Set rs = db.OpenRecordset(sSQLStmt, dbOpenDynaset)
      End If
    End If
    

    While Not rs.EOF
            sData = RTrim$(rs("LastName")) & ", " & RTrim$(rs("OrderDate")) & ", " & RTrim$(rs("ShipDate"))
            nRows = nRows + 1
            rs.MoveNext
    Wend
        
    rs.Close
    JetSelectJoin = nRows

End Function
