Attribute VB_Name = "BOOK"
Option Explicit
'Command line Arguments
' TIMEALL  - Times all data access
' TIMEDL   - Times only the data load data access
' TIMEAPP  - Times the front end application data access
' TIMEBOOK - Times the loading of the books list box
' TIMEBUY  - Times the buying of books
' TIMESTORE- Times the loading of the stores combo box

        
Global Const gENTER = 13  'Asc value for the enter key

'Mousepointer options
Global Const gHOURGLASS = 11
Global Const gDEFAULT = 0

Global Const gMODAL = 1

'Table Names
Global Const gTITLES_TABLE = "Titles"
Global Const gAUTHORS_TABLE = "Authors"
Global Const gSTORES_TABLE = "Stores"
Global Const gTITLE_AUTHOR_TABLE = "TitleAuthor"
Global Const gSALES_TABLE = "sales"

'Table Record Identifiers
Global Const gSALESID$ = "SALE" 'Format SALExxxxxxxx '20 characters (added sale will be SALES + what is entered for ord_num)
Global Const gTITLESID$ = "TT"  'Format TTxxxx       '6 characters
Global Const gAUTHORSID$ = "AU" 'Format AUxxxxxxxxx  '11 characters
Global Const gSTORESID$ = "Z"   'Format Zxxx         '4 characters

'Table Max records we will allow adding
Global Const gMAXTITLES& = 9999
Global Const gMAXAUTHORS& = 99999       'Limiting to 10 mil
Global Const gMAXSTORES& = 999
Global Const gMAXSALES& = 9999999         'Limiting to 10 mil

Global gstrTitleArray() As String
Global gstrStoreArray() As String

Global gstrStoreId$
Global gintQuant%
Global gstrOrderNumber$
Global gstrPayTerms$


'Performance Variables
Global varSTART As Variant
Global varEnd As Variant

Global gCONNECT$
Sub BuyBook(lstboxidx%)
    Dim dbPubs As Database
    Dim rstSales As Recordset
    
    varSTART = Timer
    If gintQuant% > 0 Then
        
        Set dbPubs = OpenDatabase("", False, False, gCONNECT$)
        
        Set rstSales = dbPubs.OpenRecordset("Select * from sales", dbOpenDynaset)
        
        rstSales.AddNew
        rstSales!title_id = gstrTitleArray(lstboxidx%)
        rstSales!stor_id = gstrStoreId$
        rstSales!ord_num = gstrOrderNumber$
        rstSales!ord_date = Now
        rstSales!qty = gintQuant%
        rstSales!payterms = gstrPayTerms$
        rstSales.Update
        rstSales.Close

        dbPubs.Close
    End If
    
    varEnd = Timer
    If Command$ = "TIMEALL" Or Command$ = "TIMEAPP" Or Command$ = "TIMEBUY" Then
        MsgBox "Buying a book took:  " & Str$(varEnd - varSTART)
    End If

End Sub

Sub LoadListBox(stCriteria$)
'This function will open or setfocus to the list screen when an enter key is struck in while the focus is
'on the Criteria text box.  Before showing the list screen it will query the database and load the list box.

    Dim dbPubs As Database          'Database to retrieve data from
    Dim rstBooks As Recordset        'recordset pointing at the database
    Dim rstCount As Recordset        'recordset to contain count of records
    Dim strListBoxRow$              'This will be the row to be added to the list box.
    Dim strSelectBooks$             'Used to put together sql strings.
    Dim strCurrentTitle$
    Dim strSearchCriteria$          'Criteria String to search on based on what field is being searched.
    Dim intSpotInTitleArray%
    Dim strAuthors$
    Dim strWhereClause$
    Dim intRecordCount%
    Dim intRecordSetOptions%
    
    varSTART = Timer
    frmBookList.lstBox.Clear        'Clean out all old values from the database.
    Set dbPubs = OpenDatabase("", False, False, gCONNECT$)   'Open the database using pre-established connect string
    
    If frmFind.optAuthor Then             'Set the find string for use later.
        strSearchCriteria$ = "au_lname like '" & stCriteria$ & "*'"
        strSearchCriteria$ = strSearchCriteria$ & " or au_fname like '" & stCriteria$ & "*'"
    Else
        strSearchCriteria$ = "title like '" & stCriteria$ & "*'"
    End If
    
    strWhereClause$ = " where"               'Set up where clause for count and select
    strWhereClause$ = strWhereClause$ & " titles.title_id = titleauthor.title_id"
    strWhereClause$ = strWhereClause$ & " and titleauthor.au_id = authors.au_id"

    Set rstCount = dbPubs.OpenRecordset("select count(*) from titles, titleauthor, authors" & strWhereClause$, dbOpenDynaset)
    intRecordCount% = rstCount(0)   'Get the count
    rstCount.Close
    If intRecordCount% = 0 Then
        MsgBox "There are no books matching this criteria"
    Else
        
        strSelectBooks$ = "Select titles.*, authors.* from titles, titleauthor, authors "
    
        strSelectBooks$ = strSelectBooks$ & strWhereClause$ & " order by title"
        Set rstBooks = dbPubs.OpenRecordset(strSelectBooks$, dbOpenDynaset)       'This should return records since we have a count

    'Verify you have found records, before assuming they are there.
        ReDim gstrTitleArray(intRecordCount%)         'Allocate Space

        strCurrentTitle$ = ""       'Clear the Title String
        strListBoxRow$ = ""        'Clear the String for Inserting into the list box
        
        intSpotInTitleArray% = 0
        rstBooks.FindFirst strSearchCriteria$
        If rstBooks.NoMatch Then
            MsgBox "There are no books matching this criteria"
        Else
            While Not rstBooks.NoMatch   '(change 5 removes)
                'Since the listbox only takes one column we must parse the data
                'into a string to be added to the list box.
                If strCurrentTitle$ <> rstBooks!title_id Then    'First we see if we are looking at a new title, or
                                                        'if this is one we have already started working on
                    If strListBoxRow$ <> "" Then          'If it is new then as long as this is not the first record
                        strListBoxRow$ = strListBoxRow$ & strAuthors$        'Add the Author string to the rest of the title
                        frmBookList.lstBox.AddItem strListBoxRow$     'Add the whole thing to the list box
                    End If
                    strAuthors$ = ""                               'Clear the author string since we are on a new title
                    gstrTitleArray(intSpotInTitleArray%) = rstBooks!title_id 'put the title in the title array, which we will access
                                                                    'from the listbox index.

                    intSpotInTitleArray% = intSpotInTitleArray% + 1    'Increment the array counter
                    strListBoxRow$ = rstBooks!Title & "   " & rstBooks!price & "   " & rstBooks!pubdate & "   "   'Put the title info together.
                End If
                If strAuthors$ <> "" Then strAuthors$ = ", "        'Add each author to the authors list
                strAuthors$ = rstBooks!au_fname & " " & rstBooks!au_lname
                strCurrentTitle$ = rstBooks!title_id                        'Save the current title before switching records.
                rstBooks.FindNext strSearchCriteria$                               'Looks for the next valued record.
            Wend
            If strListBoxRow$ <> "" Then                     'We still must add the last item to the list.
                strListBoxRow$ = strListBoxRow$ & strAuthors$
                frmBookList.lstBox.AddItem strListBoxRow$
            End If
            frmBookList.Show                        'Now show the form.
        End If
    End If
    rstBooks.Close
    dbPubs.Close
      
    varEnd = Timer
    If Command$ = "TIMEALL" Or Command$ = "TIMEAPP" Or Command$ = "TIMEBOOK" Then
        MsgBox "Loading Books took:  " & Str$(varEnd - varSTART)
    End If

End Sub

Sub LoadStores()
    Dim dbPubs As Database
    Dim rstStores As Recordset
    Dim intStoreArrayIndex%
    Dim strStoreInfo$
    Dim intFieldIndex%
    Dim rstStoresCount As Recordset
    Dim intRecordCount%
    Dim varRecArray As Variant
    Dim strSelectStmt$
    
    varSTART = Timer
    
    Set dbPubs = OpenDatabase("", False, False, gCONNECT$)

    Set rstStoresCount = dbPubs.OpenRecordset("Select count(*) from stores", dbOpenDynaset)
    intRecordCount% = rstStoresCount(0)
    rstStoresCount.Close
     
    strSelectStmt$ = "Select stor_id, stor_name, stor_address, city, state, zip from stores order by stor_name, State, Zip, city, stor_address"
    Set rstStores = dbPubs.OpenRecordset(strSelectStmt$, dbOpenDynaset)
    
    ReDim gstrStoreArray(intRecordCount%)
    intStoreArrayIndex% = 0
    While Not rstStores.EOF
        gstrStoreArray(intStoreArrayIndex%) = rstStores("stor_id")
        strStoreInfo$ = ""
        For intFieldIndex% = 1 To rstStores.Fields.Count - 1    'Start at the second field
            If Not IsNull(rstStores(intFieldIndex%)) And rstStores(intFieldIndex%) <> "" Then
                strStoreInfo$ = strStoreInfo$ & rstStores(intFieldIndex%) & " "
            End If
        Next intFieldIndex%
        frmWelcome!cboStoreName.AddItem Trim$(strStoreInfo$)
        rstStores.MoveNext
        intStoreArrayIndex% = intStoreArrayIndex% + 1
    Wend
    rstStores.Close
    dbPubs.Close
    
    varEnd = Timer
    If Command$ = "TIMEALL" Or Command$ = "TIMEAPP" Or Command$ = "TIMESTORE" Then
        MsgBox "Loading Stores Combo took:  " & Str$(varEnd - varSTART)
    End If

End Sub

