Attribute VB_Name = "modMain"
'/*******************************************************************
' *
' *   VBPJ Threading Sample Application
' *   Copyright  1996 Stephen R. Husak
' *
' *   PROJECT   : VBPJ
' *   MODULE    : modMain   (modMain.bas)
' *   AUTHOR    : 12/27/95  SRH
' *
' *   PURPOSE   : this module contains auxilary functions, constants,
' *               & global variables specific to the application
' *
' *   REVISIONS : 12/27/95  SRH   Original Module Creation
' *               01/01/96  SRH   changed DirData structure to match DLL
' *               01/05/96  SRH   added full commentation
' *******************************************************************/
Option Explicit

'/*
' * Application Global Constants
' */
Public Const APP_DLLPATHNAME = "thread.dll" ' path and file name of DLL
Public Const MAX_FILE_SPEC = 10             ' file spec length should not exceed this
Public Const MAX_FILE_PATH = 256            ' path length should not exceed this
                                            ' this are set to these values since in
                                            ' this example, file spec is always *.*
                                            ' and the path in the type is always
                                            ' two characters (drive letter & :) C:
'/*
' * Application Global Variables
' */
Public gh_Library As Long           ' handle to the dll instance
Public gh_Thread As Long            ' handle to the running thread

'/*
' * Application Global Structures
' */
Public Type DIRDATA
  hWndList As Long                    ' handle to list box for data output
  hWndDirs As Long                    ' handle to text box for directory count
  hWndFiles As Long                   ' handle to text box for file count
  sFileSpec As String * MAX_FILE_SPEC ' file specification (eg. *.*)
  lFileSpecLen As Long                ' length of filespec in characters
  sPath As String * MAX_FILE_PATH     ' path (eg. C:\)
  lPathLen As Long                    ' length of path in characters
End Type

'/*
' * Application Function Prototypes
' */
Declare Sub DirBrowse Lib "thread.dll" (ByVal path As String, ByVal filespec As String, hWndList As Long, hWndDirs As Long, hWndFiles As Long)

'/*
' * Win32 API Constants
' */
Public Const STATUS_PENDING = &H103
Public Const STILL_ACTIVE = STATUS_PENDING

'/*
' * Win32 API Function Prototypes
' */
Declare Function TerminateThread Lib "kernel32" (ByVal hThread As Long, ByVal dwExitCode As Long) As Long
Declare Function GetExitCodeThread Lib "kernel32" (ByVal hThread As Long, lpExitCode As Long) As Long
Declare Function CreateThread Lib "kernel32" (lpThreadAttributes As Any, ByVal dwStackSize As Long, ByVal lpStartAddress As Long, lpParameter As Any, ByVal dwCreationFlags As Long, lpThreadId As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long
Declare Function GetModuleHandle Lib "kernel32" Alias "GetModuleHandleA" (ByVal lpModuleName As String) As Long
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function CreateEvent Lib "kernel32" Alias "CreateEventA" (lpEventAttributes As Any, ByVal bManualReset As Long, ByVal bInitialState As Long, ByVal lpName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long


'/*******************************************************************
' *
' *   FUNCTION : EndApp
' *              (VOID)
' *
' *   RETURN   : VOID
' *
' *   PURPOSE  : this function cleans up and ends the application
' *
' ******************************************************************/
Sub EndApp()
  Dim rc As Long
  
  ' free the dll
  rc = FreeLibrary(gh_Library)
  
  ' unload forms
  Unload frmMain
  Unload frmRunning
  
  ' end the app
  End
End Sub

'/*******************************************************************
' *
' *   FUNCTION : Main
' *              (VOID)
' *
' *   RETURN   : VOID
' *
' *   PURPOSE  : this is the where the application starts and
' *              initializes the app and brings up the first form
' *
' ******************************************************************/
Sub Main()
  
  ' load the auxilary dll and get a global handle to it
  gh_Library = LoadLibrary(APP_DLLPATHNAME)
  
  ' load the forms in the application
  Load frmMain
  Load frmRunning
  
  ' show main form
  frmMain.Show
End Sub

