Option Explicit
    Declare Function GetTickCount Lib "User" () As Long
    Declare Function GetPixel Lib "GDI" (ByVal hDC As Integer, ByVal X As Integer, ByVal Y As Integer) As Long
    Declare Function SetPixel Lib "GDI" (ByVal hDC As Integer, ByVal X As Integer, ByVal Y As Integer, ByVal crColor As Long) As Long

Global Const TIME_DEBUG = 1
Global Const TIME_msgbox = 2
Global Const TIME_PRINTER = 3
Global glTimeBegin As Long
Global glTimeEnd As Long
Global gsTimeCaption As String
Global giTimePrintMode As Integer

'This is the code for the BeginTime subroutine:
Sub begintime (Caption As String, mode As Integer)

gsTimeCaption = Caption
giTimePrintMode = mode
glTimeBegin = GetTickCount()

End Sub

Sub Emboss3d (ctl As Control, CopyCtl As Control, Raised As Integer, Heavy As Integer, Backcolor As Long, LightColor As Long, DarkColor As Long)
Dim Lite As Long, Dark As Long
Dim foobar As Integer, foo As Integer

begintime "Emboss3d", TIME_msgbox

'Adjust colors for shade type
If Raised Then
    Lite = LightColor
    Dark = DarkColor
Else 'Indented
    Lite = DarkColor
    Dark = LightColor
End If

'Init controls
ctl.ScaleMode = 3
ctl.AutoRedraw = True
CopyCtl.ScaleMode = 3
CopyCtl.Height = ctl.Height
CopyCtl.Width = ctl.Width
CopyCtl.Picture = ctl.Image

'Emboss the shades
foobar = 0
Do Until foobar = ctl.ScaleHeight - 1
    foobar = foobar + 1
    foo = 0
    Do Until foo = ctl.ScaleWidth - 1
        foo = foo + 1
        If CopyCtl.Point(foo, foobar) = Backcolor Then
            If Heavy Or Not (Raised) Then
                If CopyCtl.Point(foo - 1, foobar - 1) <> Backcolor Then
                    ctl.PSet (foo, foobar), Dark
                Else
                    If CopyCtl.Point(foo - 1, foobar) <> Backcolor Then
                        ctl.PSet (foo, foobar), Dark
                    End If
                End If
            End If
        Else
            If Heavy Or Raised Then
                If CopyCtl.Point(foo, foobar) <> Backcolor Then
                    If CopyCtl.Point(foo - 1, foobar) = Backcolor Then
                        ctl.PSet (foo - 1, foobar), Lite
                    End If
                    If CopyCtl.Point(foo, foobar - 1) = Backcolor Then
                        ctl.PSet (foo, foobar - 1), Lite
                    End If
                End If
            End If
        End If
    Loop
Loop


'Restore the scalemode
ctl.ScaleMode = 1
CopyCtl.ScaleMode = 1
Endtime

End Sub

Sub Emboss3dC (ctl As Control, CopyCtl As Control, Raised As Integer, Heavy As Integer, Backcolor As Long, LightColor As Long, DarkColor As Long)
Dim Lite As Long, Dark As Long, Dummy As Long, PixCount As Long
Dim foobar As Integer, foo As Integer
Dim PicWidth As Long, PicHeight As Long, CtlHdc As Long

begintime "Tuned Emboss C - Store Pixels to Array", TIME_msgbox

If Raised Then
    Lite = LightColor
    Dark = DarkColor
Else 'Indented
    Lite = DarkColor
    Dark = LightColor
End If

ctl.ScaleMode = 3
ctl.AutoRedraw = True
CopyCtl.ScaleMode = 3
CopyCtl.Height = ctl.Height
CopyCtl.Width = ctl.Width
CopyCtl.Picture = ctl.Image
PicHeight = ctl.ScaleHeight - 1
PicWidth = ctl.ScaleWidth - 1

ReDim PicPixels(PicWidth, PicHeight) As Long
CtlHdc = CopyCtl.hDC
For foobar = 0 To PicHeight
    For foo = 0 To PicWidth
        PicPixels(foo, foobar) = GetPixel(CtlHdc, foo, foobar)
    Next foo
Next foobar
CtlHdc = ctl.hDC
For foobar = 1 To PicHeight
    For foo = 1 To PicWidth
        If PicPixels(foo, foobar) = Backcolor Then
            If Heavy Or Not (Raised) Then
                If PicPixels(foo - 1, foobar - 1) <> Backcolor Then
                    Dummy = SetPixel(CtlHdc, foo, foobar, Dark)
                Else
                    If PicPixels(foo - 1, foobar) <> Backcolor Then
                        Dummy = SetPixel(CtlHdc, foo, foobar, Dark)
                    End If
                End If
            End If
        Else
            If Heavy Or Raised Then
                If PicPixels(foo, foobar) <> Backcolor Then
                    If PicPixels(foo - 1, foobar) = Backcolor Then
                        Dummy = SetPixel(CtlHdc, foo - 1, foobar, Lite)
                    End If
                    If PicPixels(foo, foobar - 1) = Backcolor Then
                        Dummy = SetPixel(CtlHdc, foo, foobar - 1, Lite)
                    End If
                End If
            End If
        End If
    Next foo
Next foobar
ctl.Refresh
ctl.ScaleMode = 1
CopyCtl.ScaleMode = 1
Endtime

End Sub

'This is the EndTime routine:
Sub Endtime ()
Static Init As Integer
Dim foo As Integer, foobar As Integer

glTimeEnd = GetTickCount()

Select Case giTimePrintMode
Case 0 'do nothing - disabled
Case 1 'Debug.print Detail
    Debug.Print Format$((glTimeEnd - glTimeBegin) / 1000#, "###0.0000"), gsTimeCaption
Case 2 'Message Box
    MsgBox gsTimeCaption & Chr$(10) & Format$((glTimeEnd - glTimeBegin) / 1000#, "###0.0000"), , "Time Profile"
Case 3 'Printer.Print Detail
    Printer.Print Format$((glTimeEnd - glTimeBegin) / 1000#, "###0.0000"), gsTimeCaption
Case 4 'Printer Stop
    Printer.EndDoc
End Select
End Sub

