' DEBUGCLS.BAS
'
' Copyright (C)Karl E. Peterson, 1996
' All Rights Reserved.
'
' Module used to clear contents of VB3 Debug window.
' Written for publication in April 1996 issue of
' Visual Basic Programmer's Journal.
' May be freely used in your applications.
'
Option Explicit

Declare Function FindWindow Lib "User" (ByVal lpClassName As Any, ByVal lpWindowName As Any) As Integer
Declare Function GetWindow Lib "User" (ByVal hWnd As Integer, ByVal wCmd As Integer) As Integer
Declare Function SendMessage Lib "User" (ByVal hWnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, lParam As Any) As Long
Declare Function ShowWindow Lib "User" (ByVal hWnd As Integer, ByVal nCmdShow As Integer) As Integer
Declare Function SetActiveWindow Lib "User" (ByVal hWnd As Integer) As Integer

Global Const GW_CHILD = 5
Global Const WM_SETTEXT = &HC
Global Const SW_SHOWNORMAL = 1
Global Const SW_HIDE = 0

Sub DebugClear ()
   Dim hDebug As Integer
   Dim hDebugTxt As Integer
   Dim nRet As Integer
   '
   ' Search for handle to Debug window.
   '
   hDebug = FindWindow("OFEDT", 0&)
   '
   ' If found, get handle to first child
   ' window, the actual textbox, and use
   ' SendMessage to set it to "".
   '
   If hDebug Then
      hDebugTxt = GetWindow(hDebug, GW_CHILD)
      nRet = SendMessage(hDebugTxt, WM_SETTEXT, 0, ByVal "")
   End If
End Sub

Sub DebugHide ()
   Dim hDebug%
   Dim nRet%
   '
   ' Search for handle to Debug window.
   '
   hDebug = FindWindow("OFEDT", 0&)
   '
   ' If found, bring it to front.
   '
   If hDebug Then
      nRet = ShowWindow(hDebug, SW_HIDE)
   End If
End Sub

Sub DebugShow ()
   Dim hDebug%
   Dim nRet%
   '
   ' Search for handle to Debug window.
   '
   hDebug = FindWindow("OFEDT", 0&)
   '
   ' If found, bring it to front.
   '
   If hDebug Then
      nRet = ShowWindow(hDebug, SW_SHOWNORMAL)
      nRet = SetActiveWindow(hDebug)
   End If
End Sub

