VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cftest"
Attribute VB_Creatable = True
Attribute VB_Exposed = True
Option Explicit

Private Type ParameterType
    Parameter   As String
    Data        As String
End Type

Dim Pairs()     As ParameterType
Dim NumPairs    As Integer

Public Sub Method_Get(Request As String, Response As String)

    Dim szName      As String
    Dim szEmail     As String
    Dim szPhone     As String
    Dim szTitle     As String
    Dim szBody      As String
    Dim szDescrip   As String
    Dim szFooter    As String
    Dim nIndex      As Integer

    '- Copy the returned data into the Pairs array
    ParseParameters Request

    '- Set local variables
    For nIndex = 1 To NumPairs
        Select Case UCase$(Pairs(nIndex).Parameter)
            Case "NAME"
                szName = Pairs(nIndex).Data
            Case "EMAILADDRESS"
                szEmail = Pairs(nIndex).Data
            Case "PHONENUMBER"
                szPhone = Pairs(nIndex).Data
        End Select
    Next

    '- Create the title
    szTitle = "OLEISAPI Demo Page"

    '- Create a reply message
    szBody = "Hello, " & szName & "! If we need to contact " & _
      "you well either reach you by phone at " & szPhone & _
      " or by email at " & szEmail

    '- Now the footer.
    szFooter = "<center><font size=1>OLEISAPI is a " & _
       "trademark of Microsoft, Inc.</font size=1></center>"

    '- Create the description
    szDescrip = "This is a reply from CFOISAPI.DLL"

    '- Send the reply
    Response = StandardPage(szTitle, szBody, szDescrip, _
       szFooter, "lyellow.gif", "logo.gif", "http://my.url.com")

End Sub


Sub ParseParameters(szRequest As String)

    Dim nPos            As Integer
    Dim szTemp          As String
    Dim szNextParam     As String
    
    szTemp = szReplaceString(szRequest, "+", " ")
    
    NumPairs = 0
    
    Do
        nPos = InStr(szTemp, "&")
        If nPos Then
            NumPairs = NumPairs + 1
            ReDim Preserve Pairs(1 To NumPairs)
            szNextParam = Left$(szTemp, nPos - 1)
            szTemp = Mid$(szTemp, nPos + 1)
            nPos = InStr(szNextParam, "=")
            If nPos Then
                Pairs(NumPairs).Parameter = Left$(szNextParam, nPos - 1)
                Pairs(NumPairs).Data = Mid$(szNextParam, nPos + 1)
            Else
                '-- an error occurred in oleisapi.dll
                Exit Do
            End If
        Else
            If Len(szTemp) Then
                NumPairs = NumPairs + 1
                ReDim Preserve Pairs(1 To NumPairs)
                nPos = InStr(szTemp, "=")
                If nPos Then
                    Pairs(NumPairs).Parameter = Left$(szTemp, nPos - 1)
                    Pairs(NumPairs).Data = Mid$(szTemp, nPos + 1)
                End If
            End If
            Exit Do
        End If
    Loop

End Sub


Function StandardPage( _
           szTitle As String, _
           szBodyText As String, _
  Optional Description As Variant, _
  Optional Footer As Variant, _
  Optional BackgroundImage As Variant, _
  Optional LogoImage As Variant, _
  Optional LogoURL As Variant) As String

    '-- This is just a work string used internally
    Dim szWorking           As String
    
    '-- Flags for the optional arguments
    Dim nBackGroundImage    As Integer
    Dim nLogoImage          As Integer
    Dim nLogoURL            As Integer
    Dim nDescription        As Integer
    
    '-- Set the argument flags
    nBackGroundImage = Not IsMissing(BackgroundImage)
    nLogoImage = Not IsMissing(LogoImage)
    nLogoURL = Not IsMissing(LogoURL)
    nDescription = Not IsMissing(Description)
    
    '-- Start with the HTML header and title
    szWorking = "Content-Type: text/html" & vbCrLf & vbCrLf _
        & "<html><head><title>" & szTitle & "</title><body"
    
    '-- Use background bitmap?
    If nBackGroundImage Then
        szWorking = szWorking & " background =" & BackgroundImage & ">"
    Else
        szWorking = szWorking & ">"
    End If

    '-- Logo image?
    If nLogoImage Then
        '-- Is there a link in the image?
        If nLogoURL Then
            szWorking = szWorking & "<a href=" & LogoURL & ">"
        End If
        
        '-- Here's the image itself
        szWorking = szWorking & "<img src=" & LogoImage & " align=left " & _
        "hspace=20 border=0>"
        
        '-- If there's a link then close the anchor.
        If nLogoURL Then
            szWorking = szWorking & "</a>"
        End If
    End If

    '-- Display the title
    szWorking = szWorking & "<H1>" & szTitle & "</H1>"
    
    '-- Display the description text
    If nDescription Then
        szWorking = szWorking & Description
    End If

    '-- Close off the top section
    szWorking = szWorking & "</head><br clear = left><hr size=7>"

    '-- Display the content and the footer
    szWorking = szWorking & "<DL><DD>" & szBodyText & "</DL><p>" _
        & "<hr size=7><p>" & Footer & "</body>"
        
    '-- Return the working copy
    StandardPage = szWorking
    
End Function

Function szReplaceString(szOriginal As String, szFind As String, szReplace As String)


    Dim szTemp  As String
    Dim nPos    As Integer
    
    szTemp = szOriginal
    
    Do
        nPos = InStr(szTemp, szFind)
        If nPos Then
            szTemp = Left$(szTemp, nPos - 1) & szReplace & Mid$(szTemp, nPos + Len(szFind))
        Else
            Exit Do
        End If
    Loop
    
    szReplaceString = szTemp
    
End Function


